#!/usr/local/bin/tcsh
# a little script to run a bbjob
#
# if ( $#argv == 0 ) then
# echo " usage: bbtrack <input file>"
# exit 1
# endif
set ichoice = $1
set itrip = $2
# File=`test`
set DIR = `pwd`
set FZ = /afs/cern.ch/user/f/frankz
#
# First check input data file exists
# if ( -f $FILE ) then
# # all is OK
# else
# echo " Input file $FILE not found!"
# exit 2
# endif
# now we cat your job which follows (up to endofmyjob) and this
# will substitute $PARAM and $DIR for us
# The job is saved in strack.$FILE.job and submitted.
# First remove any old job with the same name.
if ( -f mtrack.job.$ichoice.$itrip.plot3 ) then
rm mtrack.job.$ichoice.$itrip.plot3
endif
# JOB STARTS AFTER THE LINE cat.
cat > mtrack.job.$ichoice.$itrip.plot3 <<endofmyjob
#!/usr/local/bin/tcsh
#
# Now for some reason your batch job will run in a temporary
# directory (I could of course just cd somewhere but......)
# this means we have to copy the input to it
# However your output files are all returned automatically
# even the input file as well unless we remove it.......
#
# get the input file
echo "I have started on `hostname`"
set verbose
# 
cp ${DIR}/a.out.plot.$ichoice.$itrip .
cp ${DIR}/multdist_kek.dat ./multdist.dat
# run your program
a.out.plot.$ichoice.$itrip > help.out 
# the other files will be returned to a directory created in
# the directory from which you submitted the job.
cat resav.out >> scan.$ichoice.trip_kek.plot
mv diff.dat ${DIR}/diff.dat.$ichoice.trip_kek.plot
# cp *.dat *.out *.output *.plot *.echo *.trip *.notrip ${DIR}
# cat ${DIR}/resav.out >> ${DIR}/scan.$ichoice.$itrip
endofmyjob
# THE END OF YOUR JOB
set STAT = $?
# above checks that the cat worked.
# the line endofmyjob is vital to terminate the cat
# (no trailing spaces either!)
if ( ! ${STAT} == 0 ) exit 99
#
chmod 744 mtrack.job.$ichoice.$itrip.plot3
fs flush mtrack.job.$ichoice.$itrip.plot3
bsub -R aix -J mtrack.$ichoice.$itrip.plot3 -q e_1nh mtrack.job.$ichoice.$itrip.plot3
# all done; maybe we check our status
bjobs 
echo " You can use bjobs or bjobs -l for details "
echo " or bpeek <job id> to look at the output"
echo " while your job is running."
echo " use bkill to kill jobs "
#

