       program diff 

c      weak-strong simulation program
c      to study diffusion due to long-range
c      beam-beam force 

       INCLUDE 'param.f'

         call init
c
c      need to include the nonlinear fields
c      in the low-beta quadrupoles...
c   
       ntrack = 100000
c       ntrack = 1000
       npart = 100
       nloss = 0

c      NORMALLY:
c      ntrack = 100000
c      npart = 100

       ampl = 0.5*10 

       amxnt=1000.
       amxxt=0.
       amynt=1000.
       amyxt=0.

c      phase space tracing (short term) or 
c      action diffusion (long term)

       iopt = 0 
c      iopt = 2 - frequency map 
c      iopt = 1 - short term, uniform distribution
c      iopt = 0 - long term, one amplitude only

       if (iopt.eq.2) then
c        frequency map 
         ntrack=1
         npart=1   
         call initcoorduni 
         if (ntrack.gt.ntmapm) then
         write(*,*) ' ntrack>ntmapm - abunai! '
         stop
         endif
         do j = 1, npart
         do i = 1, ntrack
         xn(j,i) = 0.
         yn(j,i) = 0.
         pxn(j,i) = 0.
         pyn(j,i) = 0.
         end do 
         xn(j,1) = x(j)/sstar
         yn(j,1) = y(j)/sstar
         pxn(j,1) = px(j)/divstar
         pyn(j,1) = py(j)/divstar
         end do 
       else if (iopt.eq.1) then
c        short term tracking      
         ntrack=500
         npart=15
cc       ntrack=2
cc       npart=2
         call initcoorduni 
       else
c        the normal case 
         call initcoord 
       endif 

       if (iopt.eq.2) then
       open(23,file="frequencymap.%j.dat")
       else if (iopt.eq.1) then
       open(22,file="phasespace.dat")
       else 
       open(20,file="diff.dat")
       open(21,file="resav.out.%k")
       endif 

       ichoice = 2 
c      ichoice = 0, only short range
c      ichoice = 1, only long range
c      ichoice = 2, lr + sr 

       itrip = 1 
c      itrip = 0, no triplet fields
c      itrip = 1, with nonlinear triplet fields
c       write(*,*) ' itrip = ',itrip 

       if (itrip.eq.1) then
       call tripletin
       endif 

       do i = 1, ntrack

       call rot(phix1,phiy1)

       call bbkick2(ichoice,itrip)

       call rot(phix2,phiy2)

       call bbkicky2(ichoice,itrip) 

       time = real(i)*timeconv        
       call tunemod (time) 

       if (mod(i,100).eq.0) then
       call overflow
       endif 

       if (iopt.ne.1) then
       call var(amx,amy) 
       amxav = amx
       amyav = amy
       ipoint = i
       call runav(amx,amy,amxav,amyav,ipoint) 

c       if (i.gt.15000) then
c       write(*,*) i, amx, amy 
c       endif 

       if (i.eq.nav) then
         axinit = amxav
         ayinit = amyav
         iinit = i
       endif

       if (i.eq.(ntrack/2)) then
         axinit = amxav
         ayinit = amyav
         iinit = i
       endif

       if (nloss.gt.0) then
         axfin = amxav
         ayfin = amyav         
         iifin = i
       endif

       if (i.eq.ntrack) then
         axfin = amxav
         ayfin = amyav         
         iifin = ntrack
       endif

       if (i.ge.nav) then
         if (mod(i,nprint).eq.0) then
         write(20,*)  i, time, amxav, amyav, nloss, npart
         endif 
       endif 

       amynt=dmin1(amynt,amyav)
       amyxt=dmax1(amyxt,amyav)
       amxnt=dmin1(amxnt,amxav)
       amxxt=dmax1(amxxt,amxav)       
       endif

       if (iopt.eq.1.or.iopt.eq.2) then
       do j = 1, npart
       xx = x(j)/sstar
       yy = y(j)/sstar
       xp = px(j)/divstar
       yp = py(j)/divstar
       if (iopt.eq.1) then
       write(22,910) i, xx, xp, yy, yp
 910   format(1x,i5,4(1x,e10.4))
       else if(iopt.eq.2) then
       ih = i+1
       if(ih.le.ntrack)then
       xn(j,ih) = xx
       yn(j,ih) = yy
       pxn(j,ih) = xp
       pyn(j,ih) = yp
       endif 
       endif 
       end do 
       endif 

       end do 

       if (iopt.eq.0) then
       slopex = (axfin-axinit)/real(iifin-iinit)
       slopey = (ayfin-ayinit)/real(iifin-iinit)
       write(21,900) ampl,slopex,slopey,ichoice,qx1,qx2,qy1,qy2 
 900   format(1x,3(1x,e10.4),1x,i2,1x,4(1x,e10.4))
       endif 

       if(iopt.eq.2) then
       do j = 1, npart
       do i = 1, ntrack 
       write(23,912) xn(j,i),pxn(j,i),yn(j,i),pyn(j,i)
 912   format(4(1x,e18.12))
       end do 
       end do 
       endif 

       if (iopt.eq.1) then
       close(22)
       else
       close(20)
       close(21)
       endif 

       write(*,*) ' lost particles = ',nloss

       end 

c
       INCLUDE 'init2.f'

       INCLUDE 'var.f'

       INCLUDE 'kicksr.f'

       INCLUDE 'kicklr.f'

       INCLUDE 'rot.f'

       INCLUDE 'bbkick2.f'

       INCLUDE 'bbkicky2.f'

       INCLUDE 'tunemod.f'

       INCLUDE 'initcoord.f'

       INCLUDE 'initcoorduni.f'

       INCLUDE 'runav.f'

       INCLUDE 'kicklry.f'

       INCLUDE 'kicktripnew.f'

       INCLUDE 'kicktripynew.f'

       INCLUDE 'tripletinnew.f'

       INCLUDE 'overflow.f'
    
