c      initialization for weak-strong
c      long-range beam-beam simulation
       subroutine init 

       INCLUDE 'param.f'

       pi = 4.*datan(1.d0)

c      classical proton radius
       rp = 1.5d-18
 
       C = 27000.
       vl = 3.d8   

       elcharge = 1.6d-19
       protonmass = 1.d9*elcharge/(vl*vl)

c      number of particles per bunch
       dnb = 1.d11

c      bunch spacing in meter
       spacing = 7.48

c      beta star and emittance
       betastar = 0.5 
       emitn = 3.75d-6
       gamma = 7461.
       emit = emitn/gamma

c      beam-beam parameter
       xi = 0.00342

c      beam size and divergence at IP 
       sstar = 15.9d-6
       divstar = 31.7d-6

c      parameter for SR beam-beam kick
       srparam = 2*rp*dnb/gamma

       thetafac = real(10)/6.
c      crossing angle
       thetac = 300.d-6*thetafac
c               300.d-6 

c      number of parasitic collision points
c      per side of IP
       npar = 18

c      phase advance from IP1 to IP2       
       qx1 = 31.655
       qx2 = 31.655
       qy1 = 29.66
       qy2 = 29.66 

       phix1 = 2.*pi*qx1
       phiy1 = 2.*pi*qy1
       phix2 = 2.*pi*qx2
       phiy2 = 2.*pi*qy2 

c      tune modulation parameters
       dpxm = 0.00 
       dpym = 0.00
       fx = 50.
       fy = 50.

c      time conversion (seconds per turn)
       timeconv = C/vl

c      number of parasitic crossings per side
       npar = 18 

c      average mean beta at triplet
       betag = 1000.

c      triplet length
       tripl = 20.

       return
       end 



     


           
